//+------------------------------------------------------------------+
//|												      geExtrapolator_sig_1.mq4|
//|                      Copyright  2007, ver 1.0							|
//|                      Forte928           									|
//+------------------------------------------------------------------+
#property copyright "Forte928"
#property link      ""
#define		IndicatorName "geExtrapolator"

#property indicator_chart_window
//#property indicator_separate_window
//#property indicator_minimum -1.5
//#property indicator_maximum 1.5
#property indicator_buffers 2
#property indicator_color1 Turquoise//CadetBlue
#property indicator_color2 Coral//GreenYellow

//---- input parameters
extern int		ExtraPrd			= 300;
extern int		FuturePrd		= 14;
extern int		HarmCount		= 21;
//extern double  FreqTOL  		=	0.0001;//Tolerance of frequency calculation for Method 1
extern int		Shift				= 0;													// -->
//extern int		OffSet			= 0;
extern int		Counter			= 1000;

//+------------------------------------------------------------+
//+                       					+
//+------------------------------------------------------------+
double	FxView1[];
double	FxView2[];
double	FxView3[];
double	FxView4[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Work Variables ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int 		Ix;
int 		Sx;
datetime	TimeCalc;

double	Rates[];
double	TimeBuf1[];
double	TimeBuf2[];
double	TimeBuf3[];
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Initialization program Buffers ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	InitBufferam(int iBufferSize)
{
	ArrayResize(Rates,iBufferSize);
	ArrayResize(TimeBuf1,iBufferSize);
	ArrayResize(TimeBuf2,iBufferSize);
	ArrayResize(TimeBuf3,iBufferSize);
	return;
}
void	EmptyBufferam()
{
	ArrayInitialize(Rates,EMPTY_VALUE);
	ArrayInitialize(TimeBuf1,EMPTY_VALUE);
	ArrayInitialize(TimeBuf2,EMPTY_VALUE);
	ArrayInitialize(TimeBuf3,EMPTY_VALUE);
// -->
	InitChart(FxView1);														// -->
	InitChart(FxView2);														// -->
	InitChart(FxView3);														// -->
	InitChart(FxView4);														// -->
	return;
}
void	DoneBufferam()
{
	ArrayResize(Rates,0);
	ArrayResize(TimeBuf1,0);
	ArrayResize(TimeBuf2,0);
	ArrayResize(TimeBuf3,0);
	//---------------------------------
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Program Constants ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int		MaxPeriod=0;
int		CalcCount=0;
//---------------------------   ------------------
//#include "ge_Extrapolator.mq4"
//#include "ge_TicketCtrl.mq4"													// -->
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator initialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
  {
//---- initialization program values  --------------------------------
	MaxPeriod=MathMax(ExtraPrd,ExtraPrd);//MathMax(ShortPrd,MathMax(SlowPrd,LongPrd)));
	InitBufferam(MaxCounter(Counter,MaxPeriod));
	CalcCount=InitCounter(Counter,MaxPeriod);
	TimeCalc=0;									// Ticket  ,     
//---- initialization indicators -------------------------------------
	SetupChartLine(0,FxView1,0,2,"LagMA"+ExtraPrd);// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(1,FxView2,0,2,"LagMA"+ExtraPrd);// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
	SetupChartLine(2,FxView3,0,2,"LagMA"+ExtraPrd);// SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); SetIndexBuffer(0,ValueBuf0);
   IndicatorShortName(IndicatorName+"("+ExtraPrd+")");
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
	
	//SetIndexShift(0,-FuturePrd);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb
	SetIndexShift(1,FuturePrd);//-OffIndex);//past data vector 0..np-1; 0 corresponds to bar=lb

	InitTicket(StringSubstr(IndicatorName,2,StringLen(IndicatorName)-2));					// -->
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator deinitialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int deinit()
  {
//----
	DoneBufferam();	
	DoneTicket();																					// -->
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Start defination ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start()
{//==========================================================================================================
	if (StartTicket(Shift)==false)											// -->
	{																					// -->
		if (!StartCounter(IndicatorName,Counter,CalcCount,MaxPeriod)) return(-1);
	}																					// -->
	else {																			// -->
		//if (cwCalculated==true) return(0);									// -->
	}																					// -->
//------------------------------------------------------------------------------------
	EmptyBufferam();
//+-------------------------- Begin Cycle ---------------------------------------------------+\\
	ReadValueTicket(Shift,Ix);											// -->

	CopySeries(Rates,MODE_CLOSE,Period(),Shift);	
	ArrayCopy(FxView1,TimeBuf1,Shift,0,ExtraPrd);

   Extrapolator(Rates,TimeBuf1,ExtraPrd,TimeBuf2,FuturePrd,HarmCount,Shift);//ForeCast
  	//ArrayCopy(View0,TimeBuf1,0,0,Counter);
  	TimeBuf2[FuturePrd]=TimeBuf1[0];
  	for (Ix=0;Ix<=CalcCount;Ix++) 
  	{
  		//TimeBuf1[Ix]=TimeBuf1[Ix]+OffSet*Point;
  		//TimeBuf2[Ix]=TimeBuf2[Ix]+OffSet*Point;
  	}
  	ArrayCopy(FxView1,TimeBuf1,Shift,0,ExtraPrd);
  	ArrayCopy(FxView2,TimeBuf2,Shift,0,FuturePrd+1);
	Comment("Shift ",Shift," LastValue ",TimeBuf1[0]," Source Value ",Rates[0]);
	CalculateFinishedTicket();													// -->

//----
   return(0);
  }//============================================================================================================

//--------------------------------------------------------------------
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 InitCounter																		~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 int InitCounter(int iPreCount,int iMaxPeriod)
{
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	int Result=MaxCounter(iPreCount,iMaxPeriod);
	// Rule 2
	if ((Result+iMaxPeriod)>Bars) Result=Bars-iMaxPeriod;
	// Rule 3
	if (Result<iMaxPeriod) Result=0;
	else Result=Result+iMaxPeriod;
	return(Result);
}
//------------------------------------------ StartCounter --------------------------
bool StartCounter(string WindowName,int iPreCount,int& iCalcCount,int iMaxPeriod)
{
	if ((iPreCount>iCalcCount)||(iPreCount==0)) iCalcCount=InitCounter(iPreCount,iMaxPeriod);
	if (iCalcCount==0) 
	{
		Alert(WindowName+" "+Symbol()+"("+Period()+") - Limited Calculate Period");
		return(false);
	}
	return(true);
	//int iBarCount=IndicatorCounted();
	//if (iBarCount>0) return(true);
	//Print("StartCounter");
	return(false);
}
//------------------------------------------ StartCounter --------------------------
int MaxCounter(int iPreCount,int iMaxPeriod)
{
	int Result=iPreCount;
	// Rule 1
	//if ((Result==0)||(Result>Bars)) Result=Bars;
	if (Result==0) Result=Bars-1;
	if (Result<iMaxPeriod) Result=iMaxPeriod;
	return(Result+iMaxPeriod);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~														 Style active Line																~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void SetupChartLine(int Index,double& ViewAy[],int Style,int Width,string Label)
{
	switch(Style)
	{
		case 0 : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
		case 1 : SetIndexStyle(Index,DRAW_HISTOGRAM,STYLE_SOLID,Width);break;
		case 2 : SetIndexStyle(Index,DRAW_ARROW,STYLE_SOLID,Width);break;
		default : SetIndexStyle(Index,DRAW_LINE,STYLE_SOLID,Width);break;
	}
	if (Label!="") SetIndexLabel(Index,Label);
	SetIndexBuffer(Index,ViewAy);
	return(0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~																CopySeries																	~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CopySeries(double& CopyRate[],int SeriesIndex,int TimeFrame,int iShift)
{
/*
	MODE_OPEN 0   	
	MODE_LOW 1   
	MODE_HIGH 2   
	MODE_CLOSE 3   
	MODE_VOLUME 4  ( ,  ) 
	MODE_TIME 5    
*/
	for (int Cx=0;Cx<ArraySize(CopyRate);Cx++)
	{
		switch (SeriesIndex)
		{
		case MODE_OPEN 	: CopyRate[Cx]=iOpen(NULL,TimeFrame,Cx+iShift);break;
		case MODE_LOW 		: CopyRate[Cx]=iLow(NULL,TimeFrame,Cx+iShift);break;
		case MODE_HIGH 	: CopyRate[Cx]=iHigh(NULL,TimeFrame,Cx+iShift);break;
		case MODE_CLOSE 	: CopyRate[Cx]=iClose(NULL,TimeFrame,Cx+iShift);break;
		case MODE_VOLUME 	: CopyRate[Cx]=iVolume(NULL,TimeFrame,Cx+iShift);break;
		case MODE_TIME 	: CopyRate[Cx]=iTime(NULL,TimeFrame,Cx+iShift);break;
		//PRICE_MEDIAN 4  , (high+low)/2 
		//PRICE_TYPICAL 5  , (high+low+close)/3 
		//PRICE_WEIGHTED 6   , (high+low+close+close)/4 
		}
	}
	return;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void InitChart(double& ayShift[])									// 
{
	if (ArraySize(ayShift)>0) ArrayInitialize(ayShift,EMPTY_VALUE);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//                                             ge_Ticket_Ctrl
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#define gnCount		"CE_Count"
#define gnTime			"CE_Time"
#define gnEmulate		"_Emulated"
#define gnCalculate	"_CW_"
#define gnPauseCount	"_PauseCount"

string	CWName			="";			//   
extern	bool	cwEmulated		=false;	//	     
bool				cwCalculated	=false;
bool				cwChecked		=false;
datetime			cwTime			=0;

void InitTicket(string PrefixValueIndicator)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	MathSrand(TimeLocal());
	CWName=gnCalculate+PrefixValueIndicator+MathRand();
	Print(CWName);
	return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool StartTicket(int iShift)	//bool iEmulate)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//cwEmulated		=iEmulate;	//
	cwCalculated	=false;
	cwChecked		=false;
	if ((GlobalVariableCheck(gnEmulate)==true)&&(cwEmulated==true))
	{
		//cwEmulated=GlobalVariableGet(cwEmulated);
		if (GlobalVariableCheck(CWName)==false) GlobalVariableSet(CWName,true);
		cwCalculated=GlobalVariableGet(CWName);
		if ((GlobalVariableCheck(gnTime)==true)&&(cwCalculated==false))
		{
			cwTime=GlobalVariableGet(gnTime);
			//Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)," : Chart Tick ",TimeToStr(cwTime,TIME_DATE|TIME_SECONDS));
			if (iBarShift(NULL,0,cwTime,false)==iShift) 
			{
				cwCalculated=true;
				GlobalVariableSet(CWName,true);
			}
		}
		cwChecked=true;
	}
	return(cwChecked);
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ReadValueTicket(int& iShift,int& iCount)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	if (cwChecked==true)
	{
		iShift=iBarShift(NULL,0,cwTime,false);
		iCount=GlobalVariableGet(gnCount);
	}
	return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void CalculateFinishedTicket()
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	if ((cwChecked==true)&&(cwCalculated==false)) GlobalVariableSet(CWName,true);
	return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void DoneTicket()
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	if (GlobalVariableCheck(CWName)==true) GlobalVariableDel(CWName);	
	Print("Delete Global Variable");
	return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~




//                                       ge_Extrapolator.mq4
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double  FreqTOL  =0.0001;//Tolerance of frequency calculation for Method 1

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~											Extrapolator	-   										~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//extern double  FreqTOL  =0.0001;//Tolerance of frequency calculation for Method 1
//extern int     Index  =30;    //Last bar in the past data
//extern int     EptPrd =300;   //Number of past bars
//extern int     FuturePrd  =100;   //Number of bars to predict; for LP is set at PastBars-Order-1 
//extern int     HarmCount   =20;    //Number of frequencies for Mathod 1; HarmNo=0 computes PastBars harmonics
//extern double  FreqTOL  =0.0001;//Tolerance of frequency calculation for Method 1
//FreqTOL > 0.001 may not converge
/*
int ForeCastExtrapolator(double& aySource[],double& ayResult[],double& ayForeCast[],int iForeCastPrd,int HarmCount)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	int ResultPrd=iForeCastPrd*4;
	Extrapolator(aySource,ayResult,ResultPrd,ayForeCast,iForeCastPrd,HarmCount,0);
	return(ResultPrd);
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
void Extrapolator(double& EptSrcAy[],double& EptOutAy[],int EptPrd,double& EptFutureAy[],int FuturePrd,int HarmCount,int Index)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   ArrayInitialize(EptOutAy,EMPTY_VALUE);
   ArrayInitialize(EptFutureAy,EMPTY_VALUE);  
   
//Find average of past values
   double Avg=0.0;
   for(int Ex=0;Ex<EptPrd;Ex++) Avg=Avg+EptSrcAy[Ex+Index];
   Avg=Avg/EptPrd;
//Prepare data
	for(Ex=0;Ex<EptPrd;Ex++)
	{
		EptOutAy[Ex]=Avg;
		if(Ex<=FuturePrd) EptFutureAy[Ex]=Avg;
	}
//Select extrapolation method
//Fit trigomometric series
	double Wept,Modept,Cosx,Sinx;
	for(int HarmNo=0;HarmNo<HarmCount;HarmNo++)
	{
		Freq(EptSrcAy,EptOutAy,EptPrd,Index,FreqTOL,Wept,Modept,Cosx,Sinx);
		for(Ex=0;Ex<EptPrd;Ex++) 
		{
			EptOutAy[Ex]+=Modept+Cosx*MathCos(Wept*Ex)+Sinx*MathSin(Wept*Ex);
			if(Ex<=FuturePrd) EptFutureAy[Ex]+=Modept+Cosx*MathCos(Wept*Ex)-Sinx*MathSin(Wept*Ex);
		}         
	}
//Reorder the predicted vector
   for(Ex=0;Ex<=(FuturePrd-1)/2;Ex++)
   {
      double tmp=EptFutureAy[Ex];
      EptFutureAy[Ex]=EptFutureAy[FuturePrd-Ex];
      EptFutureAy[FuturePrd-Ex]=tmp;
   } 
   EptFutureAy[FuturePrd+1]=EptOutAy[0];/**/
	return(0);
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~																																				~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Quinn and Fernandes algorithm
//extern double  FreqTOL  =0.0001;//Tolerance of frequency calculation for Method 1

void Freq(double& aySource[],double& ayResult[],int FreqPrd,int Index,double  iFreqTOL,double& WeFr, double& ModeFr, double& Cose, double& Sine)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   double ayZeq[];
   double FrNum;
   double FrDiv;
   ArrayResize(ayZeq,FreqPrd);
   double a=0.0;
   double b=2.0;
   ayZeq[0]=aySource[Index]-ayResult[0];
   while(MathAbs(a-b)>iFreqTOL)
   {
      a=b;
      ayZeq[1]=aySource[1+Index]-ayResult[1]+a*ayZeq[0];
      FrNum=ayZeq[0]*ayZeq[1];
      FrDiv=ayZeq[0]*ayZeq[0];
      for(int Qx=2;Qx<FreqPrd;Qx++)
      {
         ayZeq[Qx]=aySource[Qx+Index]-ayResult[Qx]+a*ayZeq[Qx-1]-ayZeq[Qx-2];
         FrNum=FrNum+ayZeq[Qx-1]*(ayZeq[Qx]+ayZeq[Qx-2]);
         FrDiv+=ayZeq[Qx-1]*ayZeq[Qx-1];
      }
      b=FrNum/FrDiv;
   }
   WeFr=MathArccos(b/2.0);
   Fit(aySource,ayResult,FreqPrd,Index,WeFr,ModeFr,Cose,Sine);
   return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~																																				~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void Fit(double& FitSrcAy[],double& FitOutAy[],int FitPrd,int Index,double Wi, double& Modi, double& Cosi, double& Sini)
{//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   double Sc=0.0;
   double Ss=0.0;
   double Scc=0.0;
   double Sss=0.0;
   double Scs=0.0;
   double Sx=0.0;
   double Sxx=0.0;
   double Sxc=0.0;
   double Sxs=0.0;
   for(int Fx=0;Fx<FitPrd;Fx++)
   {
      double FitCos=MathCos(Wi*Fx);
      double FitSin=MathSin(Wi*Fx);
      Sc=Sc+FitCos;
      Ss=Ss+FitSin;
      Scc=Scc+FitCos*FitCos;
      Sss=Sss+FitSin*FitSin;
      Scs=Scs+FitCos*FitSin;
      Sx=Sx+(FitSrcAy[Fx+Index]-FitOutAy[Fx]);
      Sxx=Sxx+MathPow(FitSrcAy[Fx+Index]-FitOutAy[Fx],2);
      Sxc=Sxc+(FitSrcAy[Fx+Index]-FitOutAy[Fx])*FitCos;
      Sxs=Sxs+(FitSrcAy[Fx+Index]-FitOutAy[Fx])*FitSin;
   }
   Sc=Sc/FitPrd;
   Ss=Ss/FitPrd;
   Scc=Scc/FitPrd;
   Sss=Sss/FitPrd;
   Scs=Scs/FitPrd;
   Sx=Sx/FitPrd;
   Sxx=Sxx/FitPrd;
   Sxc=Sxc/FitPrd;
   Sxs=Sxs/FitPrd;
   if(Wi==0.0)
   {
      Modi=Sx;
      Cosi=0.0;
      Sini=0.0;
   }
   else
   {
      //calculating Cosi, Sini, and m
      double den=MathPow(Scs-Sc*Ss,2)-(Scc-Sc*Sc)*(Sss-Ss*Ss);
      Cosi=((Sxs-Sx*Ss)*(Scs-Sc*Ss)-(Sxc-Sx*Sc)*(Sss-Ss*Ss))/den;
      Sini=((Sxc-Sx*Sc)*(Scs-Sc*Ss)-(Sxs-Sx*Ss)*(Scc-Sc*Sc))/den;
      Modi=Sx-Cosi*Sc-Sini*Ss;
   }
   return;
}//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~																																				~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

